﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AntlrVerilogParser
{
    public class VerilogCode // trieda pre otvorenie verilog subora alebo suborov, spojenie suborov do jedneho stringu
    {
        private List<String> _filenames;
        private int _lines;

        public List<String> GetFilesNames()
        {
            return _filenames;
        }

        public VerilogCode()
        {
            _filenames = new List<string>();
            _searchedname = "";
            _lines = 0;
        }

        public void AddVerilogFile(String file)
        {
            for (int i = 0; i < _filenames.Count; i++)
                if (_filenames[i] == file)
                    return;
            _lines += CountLines(file);
            if (_lines > 1000)
                throw new Exception("Error: Max length of file limit reached!");
            _filenames.Insert(_filenames.Count, file);
        }

        public bool DeleteVerilogFile(String file)
        {
            if (_filenames.Count > 1)
                for (int i = 0; i < _filenames.Count; i++)
                    if (_filenames[i] == file)
                    {
                        _lines -= CountLines(file);
                        _filenames.RemoveAt(i);
                        return true;
                    }
            return false;
        }
        public String GetVerilogFileName(int index)
        {
            return _filenames[index];
        }

        public String GetVerilogCode(int index)
        {
            return System.IO.File.ReadAllText(_filenames[index]);
        }
        public String GetVerilogCode(String filename)
        {
            _searchedname = filename;
            return System.IO.File.ReadAllText(_filenames[(_filenames.FindIndex(IsStr))]);
        }
        private bool IsStr(String value)
        {
            if (value == _searchedname)
                return true;
            else
                return false;
        }
        private String _searchedname;
        public String GetVerilogCode()
        {
            String str = "";
            foreach (String fname in _filenames)
                str = str + '\n' + System.IO.File.ReadAllText(fname);
            return str;
        }

        private int CountLines(String file)
        {
            char[] buffer = new char[32 * 1024]; // Read 32K chars at a time

            int total = 1; // All files have at least one line!

            int read;
            using (System.IO.StreamReader reader = new System.IO.StreamReader(file))
            {
                while ((read = reader.Read(buffer, 0, buffer.Length)) > 0)
                {
                    for (int i = 0; i < read; i++)
                    {
                        if (buffer[i] == '\n')
                        {
                            total++;
                        }
                    }
                }
            }
            return total;
        }
    }
}
