﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Linq;

using Dataweb.NShape;
using Dataweb.Utilities;
using Dataweb.NShape.GeneralShapes;
using Dataweb.NShape.GeneralModelObjects;
using Dataweb.NShape.Advanced;
using Dataweb.NShape.WinFormsUI;
using Dataweb.NShape.Layouters;

using GraphicalObjects;

using HDL_XML_Parser;
using HDLVisualizerDefinitions;



namespace HDLVisualizer
{
    public partial class main : Form
    {

        XDocument XMLProject;

        public static CachedRepository Repository1 = new CachedRepository();
        public static Project Project1 = new Project();
        public static Diagram Diagram1 = new Diagram("Diagram 1");
        public static PositionGenerator Generator = new PositionGenerator();

        public static DisplayInitializator Initializator = new DisplayInitializator(ref Diagram1, ref Project1, ref Repository1);

        public  static List<Modules> ModulesList = new List<Modules>();
        public  static List<Ports> PortsList = new List<Ports>();
        public  static List<Signals> SignalsList = new List<Signals>();
        public static string openXMLFile = null;


        public main()
        {
            InitializeComponent();
            Initializator.InitializeDisplay();
            diagramSetController1.Project = Project1;
        }

        //tlacitko about - vytvorenie formulara About
        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmAbout about = new frmAbout();
            about.ShowDialog(this);
        }

        #region New
        //create new Untitled-VHDL.vhdl file
        private void vHDLSourceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TabPage tab = new TabPage();
            tab.Name = "unsaved";
            tab.Text = "Untitled-VHDL.vhdl*";
            SourceFiles.TabPages.Add(tab);
            //prida textbox
            TextBox text = new TextBox();
            text.Multiline = true;
            text.ScrollBars = ScrollBars.Both;
            text.Left = 0;
            text.Top = 0;
            text.Height = tab.Height;
            text.Width = tab.Width;
            text.TextChanged += new System.EventHandler(this.textBox_TextChanged);
            tab.Controls.Add(text);
            SourceFiles.SelectedTab = tab;

            saveToolStripMenuItem.Enabled = true;
            saveAllToolStripMenuItem.Enabled = true;
            saveAsToolStripMenuItem.Enabled = true;
        }

        //create new Untitled-Verilog.v file
        private void verilogSourceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TabPage tab = new TabPage();
            tab.Name = "unsaved";
            tab.Text = "Untitled-Verilog.vhdl*";
            SourceFiles.TabPages.Add(tab);
            //prida textbox
            TextBox text = new TextBox();
            text.Multiline = true;
            text.ScrollBars = ScrollBars.Both;
            text.Left = 0;
            text.Top = 0;
            text.Height = tab.Height;
            text.Width = tab.Width;
            text.TextChanged += new System.EventHandler(this.textBox_TextChanged);
            tab.Controls.Add(text);
            SourceFiles.SelectedTab = tab;

            saveToolStripMenuItem.Enabled = true;
            saveAllToolStripMenuItem.Enabled = true;
            saveAsToolStripMenuItem.Enabled = true;
        }

        //create new Untitled-SystemC.cpp file
        private void systemCSourceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TabPage tab = new TabPage();
            tab.Name = "unsaved";
            tab.Text = "Untitled-SystemC.vhdl*";
            SourceFiles.TabPages.Add(tab);
            //prida textbox
            TextBox text = new TextBox();
            text.Multiline = true;
            text.ScrollBars = ScrollBars.Both;
            text.Left = 0;
            text.Top = 0;
            text.Height = tab.Height;
            text.Width = tab.Width;
            text.TextChanged += new System.EventHandler(this.textBox_TextChanged);
            tab.Controls.Add(text);
            SourceFiles.SelectedTab = tab;

            saveToolStripMenuItem.Enabled = true;
            saveAllToolStripMenuItem.Enabled = true;
            saveAsToolStripMenuItem.Enabled = true;
        }
        #endregion

        #region Open
        //open *.vhdl,*.vhd file
        private void vHDLSourceToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            open.Filter = "VHDL source files (*.vhd,*.vhdl)|*.vhd;*.vhdl";
            open.Title = "Select a VHDL source file";

            if (open.ShowDialog() == DialogResult.OK)
            {
                StreamReader reader = new StreamReader(open.FileName);
                //prida tab
                TabPage tab = new TabPage();
                tab.Name = open.FileName;
                tab.Text = open.SafeFileName;
                SourceFiles.TabPages.Add(tab);
                //prida textbox
                TextBox text = new TextBox();
                text.Multiline = true;
                text.ScrollBars = ScrollBars.Both;
                text.Left = 0;
                text.Top = 0;
                text.Height = tab.Height;
                text.Width = tab.Width;
                text.Text = reader.ReadToEnd();
                text.TextChanged += new System.EventHandler(this.textBox_TextChanged);
                tab.Controls.Add(text);
                SourceFiles.SelectedTab = tab;
                reader.Close();
                saveAsToolStripMenuItem.Enabled = true;
            }
        }

        //open *.v file
        private void verilogSourceToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            open.Filter = "Verilog source files (*.v)|*.v";
            open.Title = "Select a Verilog source file";

            if (open.ShowDialog() == DialogResult.OK)
            {
                StreamReader reader = new StreamReader(open.FileName);
                //prida tab
                TabPage tab = new TabPage();
                tab.Text = open.SafeFileName;
                tab.Name = open.FileName;
                SourceFiles.TabPages.Add(tab);
                //prida textbox
                TextBox text = new TextBox();
                text.Multiline = true;
                text.ScrollBars = ScrollBars.Both;
                text.Left = 0;
                text.Top = 0;
                text.Height = tab.Height;
                text.Width = tab.Width;
                text.Text = reader.ReadToEnd();
                text.TextChanged += new System.EventHandler(this.textBox_TextChanged);
                tab.Controls.Add(text);
                SourceFiles.SelectedTab = tab;
                reader.Close();
                saveAsToolStripMenuItem.Enabled = true;

            }
        }

        //open *.cpp file
        private void systemCSourceToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            open.Filter = "SystemC source files (*.cpp)|*.cpp";
            open.Title = "Select a SystemC source file";

            if (open.ShowDialog() == DialogResult.OK)
            {
                StreamReader reader = new StreamReader(open.FileName);
                //prida tab
                TabPage tab = new TabPage();
                tab.Text = open.SafeFileName;
                tab.Name = open.FileName;
                SourceFiles.TabPages.Add(tab);
                //prida textbox
                TextBox text = new TextBox();
                text.Multiline = true;
                text.ScrollBars = ScrollBars.Both;
                text.Left = 0;
                text.Top = 0;
                text.Height = tab.Height;
                text.Width = tab.Width;
                text.Text = reader.ReadToEnd();
                text.TextChanged += new System.EventHandler(this.textBox_TextChanged);
                tab.Controls.Add(text);
                SourceFiles.SelectedTab = tab;
                reader.Close();
                saveAsToolStripMenuItem.Enabled = true;
            }
        }

        //open *.xhdl file
        private void xHDLSourceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            open.Filter = "xHDL source files (*.xhdl)|*.xhdl";
            open.Title = "Select a xHDL source file";

            if (open.ShowDialog() == DialogResult.OK)
            {
                StreamReader reader = new StreamReader(open.FileName);
                openXMLFile = open.FileName;
                //prida tab
                TabPage tab = new TabPage();
                tab.Text = open.SafeFileName;
                tab.Name = open.FileName;
                SourceFiles.TabPages.Add(tab);
                //prida textbox
                TextBox text = new TextBox();
                text.Multiline = true;
                text.ScrollBars = ScrollBars.Both;
                text.Left = 0;
                text.Top = 0;
                text.Height = tab.Height;
                text.Width = tab.Width;
                text.Text = reader.ReadToEnd();
                text.TextChanged += new System.EventHandler(this.textBox_TextChanged);
                tab.Controls.Add(text);
                SourceFiles.SelectedTab = tab;
                reader.Close();
                saveAsToolStripMenuItem.Enabled = true;
            }
        }
        #endregion

        #region Save
        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string Path;
            if (SourceFiles.SelectedTab.Name == "unsaved")
            {
                SaveFileDialog save = new SaveFileDialog();
                if (SourceFiles.SelectedTab.Text.LastIndexOf("VHDL") != -1)
                {
                    save.Filter = "VHDL source files (*.vhdl)|*.vhdl";
                    save.Title = "Save a VHDL source file";
                }
                if (SourceFiles.SelectedTab.Text.LastIndexOf("Verilog") != -1)
                {
                    save.Filter = "Verilog source files (*.v)|*.v";
                    save.Title = "Save a Verilog source file";
                }
                if (SourceFiles.SelectedTab.Text.LastIndexOf("SystemC") != -1)
                {
                    save.Filter = "SystemC source files (*.cpp)|*.cpp";
                    save.Title = "Save a SystemC source file";
                }
                save.ShowDialog();
                Path = save.FileName;
            }
            else
                Path = SourceFiles.SelectedTab.Name;

            StreamWriter writer = new StreamWriter(Path);
            TextBox txt = new TextBox();
            if (SourceFiles.SelectedTab.Controls[0] is TextBox)
                txt = (TextBox)SourceFiles.SelectedTab.Controls[0];
            string text = txt.Text;
            writer.Write(text);
            writer.Close();

            SourceFiles.SelectedTab.Text = Path.Substring(Path.LastIndexOf("\\") + 1, Path.Length - Path.LastIndexOf("\\") - 1);
            SourceFiles.SelectedTab.Name = Path;
            saveToolStripMenuItem.Enabled = false;
            int pom = 0;
            foreach (TabPage tab in SourceFiles.Controls)
                if (tab.Text.LastIndexOf('*') != -1)
                    pom++;
            if (pom == 0)
                saveAllToolStripMenuItem.Enabled = false;
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string Path;
            SaveFileDialog save = new SaveFileDialog();
            save.Filter = "VHDL source files (*.vhdl,*.vhd)|*.vhdl|Verilog source files (*.v)|*.v|SystemC source files (*.cpp)|*.cpp|Text files (*.txt)|*.txt|Any files (*.*)|*.*";
            save.Title = "Save a source file as";
            save.ShowDialog();
            Path = save.FileName;

            StreamWriter writer = new StreamWriter(Path);
            TextBox txt = new TextBox();
            if (SourceFiles.SelectedTab.Controls[0] is TextBox)
                txt = (TextBox)SourceFiles.SelectedTab.Controls[0];
            string text = txt.Text;
            writer.Write(text);
            writer.Close();

            SourceFiles.SelectedTab.Text = Path.Substring(Path.LastIndexOf("\\") + 1, Path.Length - Path.LastIndexOf("\\") - 1);
            SourceFiles.SelectedTab.Name = Path;
            saveToolStripMenuItem.Enabled = false;
            int pom = 0;
            foreach (TabPage tab in SourceFiles.Controls)
                if (tab.Text.LastIndexOf('*') != -1)
                    pom++;
            if (pom == 0)
                saveAllToolStripMenuItem.Enabled = false;
        }

        private void saveAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (TabPage tab in SourceFiles.Controls)
            {
                if (tab.Text.LastIndexOf('*') != -1)
                {
                    SourceFiles.SelectedTab = tab;

                    string Path;
                    if (tab.Name == "unsaved")
                    {
                        SaveFileDialog save = new SaveFileDialog();
                        if (tab.Text.LastIndexOf("VHDL") != -1)
                        {
                            save.Filter = "VHDL source files (*.vhdl)|*.vhdl";
                            save.Title = "Save a VHDL source file";
                        }
                        if (tab.Text.LastIndexOf("Verilog") != -1)
                        {
                            save.Filter = "Verilog source files (*.v)|*.v";
                            save.Title = "Save a Verilog source file";
                        }
                        if (tab.Text.LastIndexOf("SystemC") != -1)
                        {
                            save.Filter = "SystemC source files (*.cpp)|*.cpp";
                            save.Title = "Save a SystemC source file";
                        }
                        save.ShowDialog();
                        Path = save.FileName;
                    }
                    else
                        Path = tab.Name;

                    StreamWriter writer = new StreamWriter(Path);
                    TextBox txt = new TextBox();
                    if (tab.Controls[0] is TextBox)
                        txt = (TextBox)tab.Controls[0];
                    string text = txt.Text;
                    writer.Write(text);
                    writer.Close();

                    saveAllToolStripMenuItem.Enabled = false;
                    saveToolStripMenuItem.Enabled = false;
                    tab.Text = Path.Substring(Path.LastIndexOf("\\") + 1, Path.Length - Path.LastIndexOf("\\") - 1);
                    tab.Name = Path;
                }
            }

        }
        #endregion

        #region Exit
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int pom = 0;
            foreach (TabPage tab in SourceFiles.Controls)
            {
                if (tab.Text.LastIndexOf("*") != -1)
                    pom++;
            }
            if (pom == 0)
                Close();
            else
                MessageBox.Show("Save all source files first !");
        }
        #endregion

        #region Visualization
        //check syntax
        private void checkSyntaxToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string output;
            //check syntax for VHDL file
            if (SourceFiles.SelectedTab.Text.IndexOf(".vhd") != -1)
            {
                VHDL2XML.Simulation GhdlSimul = new VHDL2XML.Simulation();
                output = GhdlSimul.GHDLSyntax(SourceFiles.SelectedTab.Name);
                if(output.IndexOf("success")!=-1)
                    MessageBox.Show("REPORT: NO ERRORS !\n" + output);
                else
                    MessageBox.Show("REPORT: ERRORS FOUND !\n" + output);
            }
            if (SourceFiles.SelectedTab.Text.IndexOf(".v") != -1)
            {
                string iverilogexe = "C:\\iverilog\\bin\\iverilog.exe";

                VerilogToXML.Verilog2XML verilog2xml = new VerilogToXML.Verilog2XML(SourceFiles.SelectedTab.Name);

                if (System.IO.File.Exists(iverilogexe))
                {
                    if (verilog2xml.CheckSyntax(SourceFiles.SelectedTab.Name, iverilogexe))
                    {
                        MessageBox.Show("REPORT: NO ERRORS !\n");
                    }
                    else
                    {
                        MessageBox.Show("REPORT: ERRORS FOUND !\n");
                    }
                }
                else
                {
                    MessageBox.Show("Invalid path to iverilog.exe!\nC:\\iverilog\\bin\\iverilog.exe");
                }
            }
        }

        //generate .xHDL
        private void parseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //VHDL
            if (SourceFiles.SelectedTab.Text[SourceFiles.SelectedTab.Text.Length - 1] == 'l')
            {
                VHDL2XML.VHDLToXML vhdlToxml = new VHDL2XML.VHDLToXML();
                TextReader fs = new StreamReader(SourceFiles.SelectedTab.Name);
                vhdlToxml.AddDesignItem(SourceFiles.SelectedTab.Name, "Work", fs.ReadToEnd());
                vhdlToxml.Parse();
                if (vhdlToxml.Architectures.Count == 0)
                {
                    MessageBox.Show("There are no architectures in the design described by structure.");
                    return;
                }
                XMLProject = vhdlToxml.GenerateXML2();
            }
            //VERILOG
            if (SourceFiles.SelectedTab.Text[SourceFiles.SelectedTab.Text.Length-1]=='v')
            {
                VerilogToXML.Verilog2XML verilog2xml = new VerilogToXML.Verilog2XML(SourceFiles.SelectedTab.Name);
                verilog2xml.Parse();
                XMLProject = verilog2xml.GenerateXVerilogXML();
            }
            string OldPath = SourceFiles.SelectedTab.Name;
            string OldName = SourceFiles.SelectedTab.Text;
            string NewPath = OldPath.Remove(OldPath.Length - OldName.Length);
            string name = OldName.Trim();
            int dot = name.LastIndexOf('.');
            string NewName = name.Substring(0,dot);
            NewName += ".xhdl";
            NewPath += NewName;
            XMLProject.Save(NewPath);

            StreamReader reader = new StreamReader(NewPath);
            TabPage tab = new TabPage();
            tab.Text = NewName;
            tab.Name = NewPath;
            SourceFiles.TabPages.Add(tab);
            //prida textbox
            TextBox text = new TextBox();
            text.Multiline = true;
            text.ScrollBars = ScrollBars.Both;
            text.Left = 0;
            text.Top = 0;
            text.Height = tab.Height;
            text.Width = tab.Width;
            text.Text = reader.ReadToEnd();
            tab.Controls.Add(text);
            SourceFiles.SelectedTab = tab;
            reader.Close();
        }
        #endregion

        #region Simulation
        //simulate
        private void simulateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //check syntax for VHDL file
            if (SourceFiles.SelectedTab.Text[SourceFiles.SelectedTab.Text.Length - 1] == 'l')
            {
                frmsimtime frmsim = new frmsimtime();
                frmsim.Name = SourceFiles.SelectedTab.Name;
                frmsim.Show();
            }
        }
        #endregion

        #region Editor
        private void textBox_TextChanged(object sender, EventArgs e)
        {
            //este sa nenachadza *
            if (SourceFiles.SelectedTab.Text.LastIndexOf('*') == -1)
            {
                SourceFiles.SelectedTab.Text = SourceFiles.SelectedTab.Text + "*";
                saveToolStripMenuItem.Enabled = true;
                saveAllToolStripMenuItem.Enabled = true;
            }
        }

        private void SourceFiles_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (SourceFiles.SelectedTab.Text.LastIndexOf('*') != -1)
                saveToolStripMenuItem.Enabled = true;
            else
                saveToolStripMenuItem.Enabled = false;
        }
        #endregion

        #region Vizualize 
        private void visualizeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string text;
            text = textBox1.Text;
            string language = "VHDL";
           // XMLParser.ParseFile(


            try
            {
                XMLParser.ParseFile(openXMLFile, out ModulesList, out PortsList, out SignalsList, out language);
            }
            catch (ExceptionExpectedAndTranslated E)
            {
                MessageBox.Show(E.GetTranslatedMessage(), "Parsing Error !");
            }
            catch (Exception E)
            {
                MessageBox.Show(E.Message);
            }

            Generator.SetModulesPosition(ref ModulesList);
            Generator.SetPortsPostion(ref ModulesList);

            Initializator.VisualizeModules(ref ModulesList);
            
            foreach (Modules module in ModulesList)
            {
                Initializator.VisualizePorts(module.GetPortList());
            }
            Initializator.VisualizeSignals(ref SignalsList);
            
            display1.CurrentTool = new PointerTool();
            Initializator.SetDiagramToRepository();
            display1.LoadDiagram("Diagram 1");
            
        }
        #endregion

    }
}
