using System;
using System.Collections.Generic;
using System.Text;

namespace VHDL2XML
{

    public enum ConfigurationFor
    {
        SpecificComponent, ALL, OTHERS
    }

    /// <summary>
    /// <para>FOR instanceName : componentname USE ENTITY entityname (architecturename)</para>
    /// <para>ComponentConfigSpec is only for instances of components (not for entities instancies)</para>
    /// </summary>
    public class ComponentConfigSpec
    {

        ConfigurationFor _ConfigurationFor;

        public ConfigurationFor ConfigurationFor
        {
            get { return _ConfigurationFor; }
            set { _ConfigurationFor = value; }
        }

        string _InstanceName = "";
        /// <summary>
        /// Moze byt aj "all"
        /// </summary>
        public string InstanceName
        {
            get { return _InstanceName; }
            set { _InstanceName = value.Trim(); }
        }

        string _ComponentName = "";

        public string ComponentName
        {
            get { return _ComponentName; }
            set { _ComponentName = value.Trim(); }
        }

        string _EntityLibraryName;

        public string EntityLibraryName
        {
            get { return _EntityLibraryName; }
            set { _EntityLibraryName = value; }
        }


        string _EntityName = "";

        public string EntityName
        {
            get { return _EntityName; }
            set 
            { 
                _EntityName = value.Trim();
                EntityLibraryName = VHDLToXML.ParseName(ref _EntityName);
            }
        }

        string _ArchitectureLibraryName;

        public string ArchitectureLibraryName
        {
            get { return _ArchitectureLibraryName; }
            set { _ArchitectureLibraryName = value; }
        }

        string _ArchitectureName = "";

        public string ArchitectureName
        {
            get { return _ArchitectureName; }
            set 
            {
                _ArchitectureName = value.Trim();
                ArchitectureLibraryName = VHDLToXML.ParseName(ref _ArchitectureName);
            }
        }
    }
}
