using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace VHDL2XML
{
    public enum portDirection
    {
        IN, OUT, INOUT, BUFFER, LINKAGE, GLOBAL
    }

    public class EntityPort : ILocation
    {
        string name;

        public string Name
        {
            get { return name; }
            set {
                name = value.Trim(); 
                RangeName = VHDLToXML.ExtractRangeName(ref name); 
            }
        }

        string rangename = "";

        public string RangeName
        {
            get { return rangename; }
            set { rangename = value; }
        }


        string type;

        public string Type
        {
            get { return type; }
            set { type = value.Trim(); }
        }

        portDirection direction;

        public portDirection Direction
        {
            get { return direction; }
            set { direction = value; }
        }

        #region ILocation Members

        private Rectangle _Position;
        public Rectangle Position
        {
            get { return _Position; }
            set { _Position = value; }
        }

        private EAnchor _Anchor;
        public EAnchor Anchor
        {
            get
            {
                return _Anchor;
            }
            set
            {
                _Anchor = value;
            }
        }

        private int _PositionIndex = -1;

        public int PositionIndex
        {
            get { return _PositionIndex; }
            set { _PositionIndex = value; }
        }

        #endregion

        #region DominoExtension
        public EntityPort()
        {
            _value = new List<string>();
            _index = new List<int>();
            _bvalue = new List<string>();
            _bindex = new List<int>();
        }
        List<int> _index;
        List<string> _value;
        public void setValue(string s, int i)
        {
            _index.Add(i);
            _value.Add(s);
        }
        public string getValue(int i)
        {
            if (_index.IndexOf(i) == -1)
                return "";
            return _value[_index.IndexOf(i)];
        }
        List<int> _bindex;
        List<string> _bvalue;
        public void setBValue(string s, int i)
        {
            _bindex.Add(i);
            _bvalue.Add(s);
        }
        public string getBValue(int i)
        {
            if (_bindex.IndexOf(i) == -1)
                return "";
            return _bvalue[_bindex.IndexOf(i)];
        }
        int _pinCount=0;
        public int pinCount
        {
            get { return _pinCount; }
            set { _pinCount = value; }
        }
        #endregion
    }
}
