﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;

namespace VHDL2XML
{
    public class Simulation
    {
        public string GHDLSyntax(string file)
        {
            string arg,error;
            
            arg = "-a " + file;
            Process proc = new Process();
            ProcessStartInfo ghdl = new ProcessStartInfo("ghdl.exe");
            ghdl.Arguments = arg;
            ghdl.UseShellExecute = false;
            ghdl.CreateNoWindow = true;
            ghdl.RedirectStandardError = true;
            proc.StartInfo = ghdl;
            proc.Start();
            error = proc.StandardError.ReadToEnd();
            proc.WaitForExit();
            if (error.Length != 0)
                return error;
            else
                return "Syntax checked successfully.";
        }

        public string GHDLtoVCD(string file, int time)
        {
            string arg, error;

            string path = file.Substring(0, file.LastIndexOf('.')) + ".vcd";
            arg = "-c " + file + " -r testbench --stop-time=" + time + "ns --vcd=" + path;
            Process proc = new Process();
            ProcessStartInfo ghdl = new ProcessStartInfo("ghdl.exe");
            ghdl.Arguments = arg;
            ghdl.UseShellExecute = false;
            ghdl.CreateNoWindow = true;
            ghdl.RedirectStandardError = true;
            proc.StartInfo = ghdl;
            proc.Start();
            error = proc.StandardError.ReadToEnd();
            proc.WaitForExit();

            Process gtk = new Process();
            ProcessStartInfo info = new ProcessStartInfo("C:\\Users\\mato\\Desktop\\skola\\4.roc\\zima\\TP1\\gtkwave\\bin\\gtkwave.exe");
            info.Arguments = path;
            gtk.StartInfo = info;
            gtk.Start();

            return error;
        }
    }
}
