﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VerilogToXML
{
    public enum NetType { wire, tri, wor, trior, wand, triand, tri0, tri1, supply0, supply1, trireg };
    public enum netType { bit, bit_vector};

    class Net
    {
        public Net(Module mod) // kazda siet net musi byt v nejakom module, implicitne je typu wire
        {
            Module = mod;
            Type = NetType.wire;
            Connections = new List<PortConnection>();
        }
        public Net(Module mod, NetType type, String name) // kazda siet net musi byt v nejakom module a byt nejakeho typu
        {
            Module = mod;
            Type = type;
            Name = name;
            Connections = new List<PortConnection>();
        }

        public netType getType()
        {
            if (Range == 1)
                return netType.bit;
            else
                return netType.bit_vector;
        }

        public NetType Type; // typ siete
        public String Name; // meno siete
        public Module Module;   // kazda siet musi byt v nejakom module

        private int _up = 0;
        private int _down = 0;  // rozsah dat. typu net
        public int Range;
        public void SetRange(int d, int u)
        {
            _up = u;
            _down = d;
            Range = Math.Abs(_up - _down) + 1;
        }

        private int _low = 0;
        private int _high = 0;  // velkost array z net

        public void SetArrayRange(int l, int h)
        {
            _low = l;
            _high = h;
        }
        public int GetArrayRange()
        {
            return Math.Abs(_high - _low)+1;
        }

        public List<PortConnection> Connections;

    }
}
